AwkMatcher (Jakarta-ORO 2.0.8 API)
Keywords: org.apache.oro.text.awk.AwkMatcher class

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.oro.text.awk
Class AwkMatcher

    java.lang.Object
      org.apache.oro.text.awk.AwkMatcher

All Implemented Interfaces:
  PatternMatcher

public final class AwkMatcher
extends java.lang.Object
implements PatternMatcher

The AwkMatcher class is used to match regular expressions (conforming to the Awk regular expression syntax) generated by AwkCompiler. AwkMatcher only supports 8-bit ASCII. Any attempt to match Unicode values greater than 255 will result in undefined behavior. AwkMatcher finds true leftmost-longest matches, so you must take care with how you formulate your regular expression to avoid matching more than you really want.

It is important for you to remember that AwkMatcher does not save parenthesized sub-group information. Therefore the number of groups saved in a MatchResult produced by AwkMatcher will always be 1.

Since:
  1.0
Version:
  2.0.8
See Also:
  `PatternMatcher`, `AwkCompiler`

Constructor Summary
`AwkMatcher()`

Method Summary
`boolean` | `contains(AwkStreamInput input, Pattern pattern)` Determines if the contents of an AwkStreamInput, starting from the current offset of the input contains a pattern.
`boolean` | `contains(char[] input, Pattern pattern)` Determines if a string (represented as a char[]) contains a pattern.
`boolean` | `contains(PatternMatcherInput input, Pattern pattern)` Determines if the contents of a PatternMatcherInput, starting from the current offset of the input contains a pattern.
`boolean` | `contains(java.lang.String input, Pattern pattern)` Determines if a string contains a pattern.
`MatchResult` | `getMatch()` Fetches the last match found by a call to a matches() or contains() method.
`boolean` | `matches(char[] input, Pattern pattern)` Determines if a string (represented as a char[]) exactly matches a given pattern.
`boolean` | `matches(PatternMatcherInput input, Pattern pattern)` Determines if the contents of a PatternMatcherInput instance exactly matches a given pattern.
`boolean` | `matches(java.lang.String input, Pattern pattern)` Determines if a string exactly matches a given pattern.
`boolean` | `matchesPrefix(char[] input, Pattern pattern)` Determines if a prefix of a string (represented as a char[]) matches a given pattern.
`boolean` | `matchesPrefix(char[] input, Pattern pattern, int offset)` Determines if a prefix of a string (represented as a char[]) matches a given pattern, starting from a given offset into the string.
`boolean` | `matchesPrefix(PatternMatcherInput input, Pattern pattern)` Determines if a prefix of a PatternMatcherInput instance matches a given pattern.
`boolean` | `matchesPrefix(java.lang.String input, Pattern pattern)` Determines if a prefix of a string matches a given pattern.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### AwkMatcher

    public AwkMatcher()

Method Detail

### matchesPrefix

    public boolean matchesPrefix(char[] input,
                                 Pattern pattern,
                                 int offset)

  Determines if a prefix of a string (represented as a char[]) matches a given pattern, starting from a given offset into the string. If a prefix of the string matches the pattern, a MatchResult instance representing the match is made accesible via `getMatch()`.

  This method is useful for certain common token identification tasks that are made more difficult without this functionality.

  Specified by:
    `matchesPrefix` in interface `PatternMatcher`
  Parameters:
    `input` - The char[] to test for a prefix match.
    `pattern` - The Pattern to be matched.
    `offset` - The offset at which to start searching for the prefix.
  Returns:
    True if input matches pattern, false otherwise.

### matchesPrefix

    public boolean matchesPrefix(char[] input,
                                 Pattern pattern)

  Determines if a prefix of a string (represented as a char[]) matches a given pattern. If a prefix of the string matches the pattern, a MatchResult instance representing the match is made accesible via `getMatch()`.

  This method is useful for certain common token identification tasks that are made more difficult without this functionality.

  Specified by:
    `matchesPrefix` in interface `PatternMatcher`
  Parameters:
    `input` - The char[] to test for a prefix match.
    `pattern` - The Pattern to be matched.
  Returns:
    True if input matches pattern, false otherwise.

### matchesPrefix

    public boolean matchesPrefix(java.lang.String input,
                                 Pattern pattern)

  Determines if a prefix of a string matches a given pattern. If a prefix of the string matches the pattern, a MatchResult instance representing the match is made accesible via `getMatch()`.

  This method is useful for certain common token identification tasks that are made more difficult without this functionality.

  Specified by:
    `matchesPrefix` in interface `PatternMatcher`
  Parameters:
    `input` - The String to test for a prefix match.
    `pattern` - The Pattern to be matched.
  Returns:
    True if input matches pattern, false otherwise.

### matchesPrefix

    public boolean matchesPrefix(PatternMatcherInput input,
                                 Pattern pattern)

  Determines if a prefix of a PatternMatcherInput instance matches a given pattern. If there is a match, a MatchResult instance representing the match is made accesible via `getMatch()`. Unlike the `contains(PatternMatcherInput, Pattern)` method, the current offset of the PatternMatcherInput argument is not updated. You should remember that the region starting from the begin offset of the PatternMatcherInput will be tested for a prefix match.

  This method is useful for certain common token identification tasks that are made more difficult without this functionality.

  Specified by:
    `matchesPrefix` in interface `PatternMatcher`
  Parameters:
    `input` - The PatternMatcherInput to test for a prefix match.
    `pattern` - The Pattern to be matched.
  Returns:
    True if input matches pattern, false otherwise.

### matches

    public boolean matches(char[] input,
                           Pattern pattern)

  Determines if a string (represented as a char[]) exactly matches a given pattern. If there is an exact match, a MatchResult instance representing the match is made accesible via `getMatch()`. The pattern must be an AwkPattern instance, otherwise a ClassCastException will be thrown. You are not required to, and indeed should NOT try to (for performance reasons), catch a ClassCastException because it will never be thrown as long as you use an AwkPattern as the pattern parameter.

  Specified by:
    `matches` in interface `PatternMatcher`
  Parameters:
    `input` - The char[] to test for an exact match.
    `pattern` - The AwkPattern to be matched.
  Returns:
    True if input matches pattern, false otherwise.
  Throws:
    `java.lang.ClassCastException` - If a Pattern instance other than an AwkPattern is passed as the pattern parameter.

### matches

    public boolean matches(java.lang.String input,
                           Pattern pattern)

  Determines if a string exactly matches a given pattern. If there is an exact match, a MatchResult instance representing the match is made accesible via `getMatch()`. The pattern must be a AwkPattern instance, otherwise a ClassCastException will be thrown. You are not required to, and indeed should NOT try to (for performance reasons), catch a ClassCastException because it will never be thrown as long as you use an AwkPattern as the pattern parameter.

  Specified by:
    `matches` in interface `PatternMatcher`
  Parameters:
    `input` - The String to test for an exact match.
    `pattern` - The AwkPattern to be matched.
  Returns:
    True if input matches pattern, false otherwise.
  Throws:
    `java.lang.ClassCastException` - If a Pattern instance other than an AwkPattern is passed as the pattern parameter.

### matches

    public boolean matches(PatternMatcherInput input,
                           Pattern pattern)

  Determines if the contents of a PatternMatcherInput instance exactly matches a given pattern. If there is an exact match, a MatchResult instance representing the match is made accesible via `getMatch()`. Unlike the `contains(PatternMatcherInput, Pattern)` method, the current offset of the PatternMatcherInput argument is not updated. You should remember that the region between the begin and end offsets of the PatternMatcherInput will be tested for an exact match.

  The pattern must be an AwkPattern instance, otherwise a ClassCastException will be thrown. You are not required to, and indeed should NOT try to (for performance reasons), catch a ClassCastException because it will never be thrown as long as you use an AwkPattern as the pattern parameter.

  Specified by:
    `matches` in interface `PatternMatcher`
  Parameters:
    `input` - The PatternMatcherInput to test for a match.
    `pattern` - The AwkPattern to be matched.
  Returns:
    True if input matches pattern, false otherwise.
  Throws:
    `java.lang.ClassCastException` - If a Pattern instance other than an AwkPattern is passed as the pattern parameter.

### contains

    public boolean contains(char[] input,
                            Pattern pattern)

  Determines if a string (represented as a char[]) contains a pattern. If the pattern is matched by some substring of the input, a MatchResult instance representing the first such match is made acessible via `getMatch()`. If you want to access subsequent matches you should either use a PatternMatcherInput object or use the offset information in the MatchResult to create a substring representing the remaining input. Using the MatchResult offset information is the recommended method of obtaining the parts of the string preceeding the match and following the match.

  The pattern must be an AwkPattern instance, otherwise a ClassCastException will be thrown. You are not required to, and indeed should NOT try to (for performance reasons), catch a ClassCastException because it will never be thrown as long as you use an AwkPattern as the pattern parameter.

  Specified by:
    `contains` in interface `PatternMatcher`
  Parameters:
    `input` - The char[] to test for a match.
    `pattern` - The AwkPattern to be matched.
  Returns:
    True if the input contains a pattern match, false otherwise.
  Throws:
    `java.lang.ClassCastException` - If a Pattern instance other than an AwkPattern is passed as the pattern parameter.

### contains

    public boolean contains(java.lang.String input,
                            Pattern pattern)

  Determines if a string contains a pattern. If the pattern is matched by some substring of the input, a MatchResult instance representing the first such match is made acessible via `getMatch()`. If you want to access subsequent matches you should either use a PatternMatcherInput object or use the offset information in the MatchResult to create a substring representing the remaining input. Using the MatchResult offset information is the recommended method of obtaining the parts of the string preceeding the match and following the match.

  The pattern must be an AwkPattern instance, otherwise a ClassCastException will be thrown. You are not required to, and indeed should NOT try to (for performance reasons), catch a ClassCastException because it will never be thrown as long as you use an AwkPattern as the pattern parameter.

  Specified by:
    `contains` in interface `PatternMatcher`
  Parameters:
    `input` - The String to test for a match.
    `pattern` - The AwkPattern to be matched.
  Returns:
    True if the input contains a pattern match, false otherwise.
  Throws:
    `java.lang.ClassCastException` - If a Pattern instance other than an AwkPattern is passed as the pattern parameter.

### contains

    public boolean contains(PatternMatcherInput input,
                            Pattern pattern)

  Determines if the contents of a PatternMatcherInput, starting from the current offset of the input contains a pattern. If a pattern match is found, a MatchResult instance representing the first such match is made acessible via `getMatch()`. The current offset of the PatternMatcherInput is set to the offset corresponding to the end of the match, so that a subsequent call to this method will continue searching where the last call left off. You should remember that the region between the begin and end offsets of the PatternMatcherInput are considered the input to be searched, and that the current offset of the PatternMatcherInput reflects where a search will start from. Matches extending beyond the end offset of the PatternMatcherInput will not be matched. In other words, a match must occur entirely between the begin and end offsets of the input. See `PatternMatcherInput` for more details.

  As a side effect, if a match is found, the PatternMatcherInput match offset information is updated. See the PatternMatcherInput `setMatchOffsets(int, int)` method for more details.

  The pattern must be an AwkPattern instance, otherwise a ClassCastException will be thrown. You are not required to, and indeed should NOT try to (for performance reasons), catch a ClassCastException because it will never be thrown as long as you use an AwkPattern as the pattern parameter.

  This method is usually used in a loop as follows:

  >      PatternMatcher matcher;
  >      PatternCompiler compiler;
  >      Pattern pattern;
  >      PatternMatcherInput input;
  >      MatchResult result;

  >      compiler = new AwkCompiler();
  >      matcher  = new AwkMatcher();

  >      try {
  >        pattern = compiler.compile(somePatternString);
  >      } catch(MalformedPatternException e) {
  >        System.err.println("Bad pattern.");
  >        System.err.println(e.getMessage());
  >        return;
  >      }

  >      input   = new PatternMatcherInput(someStringInput);

  >      while(matcher.contains(input, pattern)) {
  >        result = matcher.getMatch();
  >        // Perform whatever processing on the result you want.
  >      }

  Specified by:
    `contains` in interface `PatternMatcher`
  Parameters:
    `input` - The PatternMatcherInput to test for a match.
    `pattern` - The Pattern to be matched.
  Returns:
    True if the input contains a pattern match, false otherwise.
  Throws:
    `java.lang.ClassCastException` - If a Pattern instance other than an AwkPattern is passed as the pattern parameter.

### contains

    public boolean contains(AwkStreamInput input,
                            Pattern pattern)
                     throws java.io.IOException

  Determines if the contents of an AwkStreamInput, starting from the current offset of the input contains a pattern. If a pattern match is found, a MatchResult instance representing the first such match is made acessible via `getMatch()`. The current offset of the input stream is advanced to the end offset corresponding to the end of the match. Consequently a subsequent call to this method will continue searching where the last call left off. See `AwkStreamInput` for more details.

  Note, patterns matching the null string do NOT match at end of input stream. This is different from the behavior you get from the other contains() methods.

  The pattern must be an AwkPattern instance, otherwise a ClassCastException will be thrown. You are not required to, and indeed should NOT try to (for performance reasons), catch a ClassCastException because it will never be thrown as long as you use an AwkPattern as the pattern parameter.

  This method is usually used in a loop as follows:

  >      PatternMatcher matcher;
  >      PatternCompiler compiler;
  >      Pattern pattern;
  >      AwkStreamInput input;
  >      MatchResult result;

  >      compiler = new AwkCompiler();
  >      matcher  = new AwkMatcher();

  >      try {
  >        pattern = compiler.compile(somePatternString);
  >      } catch(MalformedPatternException e) {
  >        System.err.println("Bad pattern.");
  >        System.err.println(e.getMessage());
  >        return;
  >      }

  >      input   = new AwkStreamInput(
  >                  new BufferedInputStream(new FileInputStream(someFileName)));

  >      while(matcher.contains(input, pattern)) {
  >        result = matcher.getMatch();
  >        // Perform whatever processing on the result you want.
  >      }

  Parameters:
    `input` - The PatternStreamInput to test for a match.
    `pattern` - The Pattern to be matched.
  Returns:
    True if the input contains a pattern match, false otherwise.
  Throws:
    `java.lang.ClassCastException` - If a Pattern instance other than an AwkPattern is passed as the pattern parameter.
    `java.io.IOException`

### getMatch

    public MatchResult getMatch()

  Fetches the last match found by a call to a matches() or contains() method.

  Specified by:
    `getMatch` in interface `PatternMatcher`
  Returns:
    A MatchResult instance containing the pattern match found by the last call to any one of the matches() or contains() methods. If no match was found by the last call, returns null.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright ? 2000-2003 Apache Software Foundation. All Rights Reserved.